## jersey.repackaged.org.objectweb.asm
Class ClassReader

    java.lang.Object
      jersey.repackaged.org.objectweb.asm.ClassReader

    public class ClassReader

extends java.lang.Object

A Java class parser to make a `ClassVisitor` visit an existing class. This class parses a byte array conforming to the Java class file format and calls the appropriate visit methods of a given class visitor for each field, method and bytecode instruction encountered.

Author:
  Eric Bruneton, Eugene Kuleshov

Field Summary
`byte[]` | `b` The class to be parsed.
`static int` | `EXPAND_FRAMES` Flag to expand the stack map frames.
`int` | `header` Start index of the class header information (access, name...) in `b`.
`static int` | `SKIP_CODE` Flag to skip method code.
`static int` | `SKIP_DEBUG` Flag to skip the debug information in the class.
`static int` | `SKIP_FRAMES` Flag to skip the stack map frames in the class.

Constructor Summary
`ClassReader(byte[] b)` Constructs a new `ClassReader` object.
`ClassReader(byte[] b, int off, int len)` Constructs a new `ClassReader` object.
`ClassReader(java.io.InputStream is)` Constructs a new `ClassReader` object.
`ClassReader(java.lang.String name)` Constructs a new `ClassReader` object.

Method Summary
`void` | `accept(ClassVisitor classVisitor, Attribute[] attrs, int flags)` Makes the given visitor visit the Java class of this `ClassReader`.
`void` | `accept(ClassVisitor classVisitor, int flags)` Makes the given visitor visit the Java class of this `ClassReader` .
`int` | `getAccess()` Returns the class's access flags (see `Opcodes`).
`java.lang.String` | `getClassName()` Returns the internal name of the class (see `getInternalName`).
`java.lang.String[]` | `getInterfaces()` Returns the internal names of the class's interfaces (see `getInternalName`).
`int` | `getItem(int item)` Returns the start index of the constant pool item in `b`, plus one.
`int` | `getItemCount()` Returns the number of constant pool items in `b`.
`int` | `getMaxStringLength()` Returns the maximum length of the strings contained in the constant pool of the class.
`java.lang.String` | `getSuperName()` Returns the internal of name of the super class (see `getInternalName`).
`int` | `readByte(int index)` Reads a byte value in `b`.
`java.lang.String` | `readClass(int index, char[] buf)` Reads a class constant pool item in `b`.
`java.lang.Object` | `readConst(int item, char[] buf)` Reads a numeric or string constant pool item in `b`.
`int` | `readInt(int index)` Reads a signed int value in `b`.
`protected Label` | `readLabel(int offset, Label[] labels)` Returns the label corresponding to the given offset.
`long` | `readLong(int index)` Reads a signed long value in `b`.
`short` | `readShort(int index)` Reads a signed short value in `b`.
`int` | `readUnsignedShort(int index)` Reads an unsigned short value in `b`.
`java.lang.String` | `readUTF8(int index, char[] buf)` Reads an UTF8 string constant pool item in `b`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### SKIP_CODE

    public static final int SKIP_CODE

  Flag to skip method code. If this class is set `CODE` attribute won't be visited. This can be used, for example, to retrieve annotations for methods and method parameters.

  See Also:
    Constant Field Values

### SKIP_DEBUG

    public static final int SKIP_DEBUG

  Flag to skip the debug information in the class. If this flag is set the debug information of the class is not visited, i.e. the `visitLocalVariable` and `visitLineNumber` methods will not be called.

  See Also:
    Constant Field Values

### SKIP_FRAMES

    public static final int SKIP_FRAMES

  Flag to skip the stack map frames in the class. If this flag is set the stack map frames of the class is not visited, i.e. the `visitFrame` method will not be called. This flag is useful when the `ClassWriter.COMPUTE_FRAMES` option is used: it avoids visiting frames that will be ignored and recomputed from scratch in the class writer.

  See Also:
    Constant Field Values

### EXPAND_FRAMES

    public static final int EXPAND_FRAMES

  Flag to expand the stack map frames. By default stack map frames are visited in their original format (i.e. "expanded" for classes whose version is less than V1_6, and "compressed" for the other classes). If this flag is set, stack map frames are always visited in expanded format (this option adds a decompression/recompression step in ClassReader and ClassWriter which degrades performances quite a lot).

  See Also:
    Constant Field Values

### b

    public final byte[] b

  The class to be parsed. The content of this array must not be modified. This field is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

### header

    public final int header

  Start index of the class header information (access, name...) in `b`.

Constructor Detail

### ClassReader

    public ClassReader(byte[] b)

  Constructs a new `ClassReader` object.

  Parameters:
    `b` - the bytecode of the class to be read.

### ClassReader

    public ClassReader(byte[] b,
                       int off,
                       int len)

  Constructs a new `ClassReader` object.

  Parameters:
    `b` - the bytecode of the class to be read.
    `off` - the start offset of the class data.
    `len` - the length of the class data.

### ClassReader

    public ClassReader(java.io.InputStream is)
                throws java.io.IOException

  Constructs a new `ClassReader` object.

  Parameters:
    `is` - an input stream from which to read the class.
  Throws:
    `java.io.IOException` - if a problem occurs during reading.

### ClassReader

    public ClassReader(java.lang.String name)
                throws java.io.IOException

  Constructs a new `ClassReader` object.

  Parameters:
    `name` - the binary qualified name of the class to be read.
  Throws:
    `java.io.IOException` - if an exception occurs during reading.

Method Detail

### getAccess

    public int getAccess()

  Returns the class's access flags (see `Opcodes`). This value may not reflect Deprecated and Synthetic flags when bytecode is before 1.5 and those flags are represented by attributes.

  Returns:
    the class access flags
  See Also:
    `ClassVisitor.visit(int, int, String, String, String, String[])`

### getClassName

    public java.lang.String getClassName()

  Returns the internal name of the class (see `getInternalName`).

  Returns:
    the internal class name
  See Also:
    `ClassVisitor.visit(int, int, String, String, String, String[])`

### getSuperName

    public java.lang.String getSuperName()

  Returns the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`.

  Returns:
    the internal name of super class, or `null` for `Object` class.
  See Also:
    `ClassVisitor.visit(int, int, String, String, String, String[])`

### getInterfaces

    public java.lang.String[] getInterfaces()

  Returns the internal names of the class's interfaces (see `getInternalName`).

  Returns:
    the array of internal names for all implemented interfaces or `null`.
  See Also:
    `ClassVisitor.visit(int, int, String, String, String, String[])`

### accept

    public void accept(ClassVisitor classVisitor,
                       int flags)

  Makes the given visitor visit the Java class of this `ClassReader` . This class is the one specified in the constructor (see `ClassReader`).

  Parameters:
    `classVisitor` - the visitor that must visit this class.
    `flags` - option flags that can be used to modify the default behavior of this class. See `SKIP_DEBUG`, `EXPAND_FRAMES` , `SKIP_FRAMES`, `SKIP_CODE`.

### accept

    public void accept(ClassVisitor classVisitor,
                       Attribute[] attrs,
                       int flags)

  Makes the given visitor visit the Java class of this `ClassReader`. This class is the one specified in the constructor (see `ClassReader`).

  Parameters:
    `classVisitor` - the visitor that must visit this class.
    `attrs` - prototypes of the attributes that must be parsed during the visit of the class. Any attribute whose type is not equal to the type of one the prototypes will not be parsed: its byte array value will be passed unchanged to the ClassWriter. This may corrupt it if this value contains references to the constant pool, or has syntactic or semantic links with a class element that has been transformed by a class adapter between the reader and the writer.
    `flags` - option flags that can be used to modify the default behavior of this class. See `SKIP_DEBUG`, `EXPAND_FRAMES` , `SKIP_FRAMES`, `SKIP_CODE`.

### readLabel

    protected Label readLabel(int offset,
                              Label[] labels)

  Returns the label corresponding to the given offset. The default implementation of this method creates a label for the given offset if it has not been already created.

  Parameters:
    `offset` - a bytecode offset in a method.
    `labels` - the already created labels, indexed by their offset. If a label already exists for offset this method must not create a new one. Otherwise it must store the new label in this array.
  Returns:
    a non null Label, which must be equal to labels[offset].

### getItemCount

    public int getItemCount()

  Returns the number of constant pool items in `b`.

  Returns:
    the number of constant pool items in `b`.

### getItem

    public int getItem(int item)

  Returns the start index of the constant pool item in `b`, plus one. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `item` - the index a constant pool item.
  Returns:
    the start index of the constant pool item in `b`, plus one.

### getMaxStringLength

    public int getMaxStringLength()

  Returns the maximum length of the strings contained in the constant pool of the class.

  Returns:
    the maximum length of the strings contained in the constant pool of the class.

### readByte

    public int readByte(int index)

  Reads a byte value in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of the value to be read in `b`.
  Returns:
    the read value.

### readUnsignedShort

    public int readUnsignedShort(int index)

  Reads an unsigned short value in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of the value to be read in `b`.
  Returns:
    the read value.

### readShort

    public short readShort(int index)

  Reads a signed short value in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of the value to be read in `b`.
  Returns:
    the read value.

### readInt

    public int readInt(int index)

  Reads a signed int value in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of the value to be read in `b`.
  Returns:
    the read value.

### readLong

    public long readLong(int index)

  Reads a signed long value in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of the value to be read in `b`.
  Returns:
    the read value.

### readUTF8

    public java.lang.String readUTF8(int index,
                                     char[] buf)

  Reads an UTF8 string constant pool item in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of an unsigned short value in `b`, whose value is the index of an UTF8 constant pool item.
    `buf` - buffer to be used to read the item. This buffer must be sufficiently large. It is not automatically resized.
  Returns:
    the String corresponding to the specified UTF8 item.

### readClass

    public java.lang.String readClass(int index,
                                      char[] buf)

  Reads a class constant pool item in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `index` - the start index of an unsigned short value in `b`, whose value is the index of a class constant pool item.
    `buf` - buffer to be used to read the item. This buffer must be sufficiently large. It is not automatically resized.
  Returns:
    the String corresponding to the specified class item.

### readConst

    public java.lang.Object readConst(int item,
                                      char[] buf)

  Reads a numeric or string constant pool item in `b`. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.

  Parameters:
    `item` - the index of a constant pool item.
    `buf` - buffer to be used to read the item. This buffer must be sufficiently large. It is not automatically resized.
  Returns:
    the `Integer`, `Float`, `Long`, `Double`, `String`, `Type` or `Handle` corresponding to the given constant pool item.

Copyright © 2017 Oracle Corporation. All Rights Reserved.